/*******************************************************************************
File Name: CYBLE_custom.c
Version 1.20

Description:
 Contains the source code for the Custom Service.

********************************************************************************
Copyright 2014-2015, Cypress Semiconductor Corporation.  All rights reserved.
You may use this file only in accordance with the license, terms, conditions,
disclaimers, and limitations in the end user license agreement accompanying
the software package with which this file was provided.
*******************************************************************************/


#include "BLE_eventHandler.h"

#if(0u != CYBLE_CUSTOMS_SERVICE_COUNT)

/* If any custom service with custom characterisctis is defined in the
* customizer's GUI their handles will be present in this array.
*/
/* This array contains attribute handles for the defined Custom Services and their characteristics and descriptors.
   The array index definitions are located in the CYBLE_custom.h file. */
const CYBLE_CUSTOMS_T cyBle_customs[0x01u] = {

    /* eBikeData service */
    {
        0x000Cu, /* Handle of the eBikeData service */ 
        {

            /* Amphour characteristic */
            {
                0x000Eu, /* Handle of the Amphour characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x000Fu, /* Handle of the Custom Descriptor descriptor */ 
                    0x0010u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Volts characteristic */
            {
                0x0012u, /* Handle of the Volts characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x0013u, /* Handle of the Custom Descriptor descriptor */ 
                    0x0014u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Amps characteristic */
            {
                0x0016u, /* Handle of the Amps characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x0017u, /* Handle of the Custom Descriptor descriptor */ 
                    0x0018u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Speed characteristic */
            {
                0x001Au, /* Handle of the Speed characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x001Bu, /* Handle of the Custom Descriptor descriptor */ 
                    0x001Cu, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Distance characteristic */
            {
                0x001Eu, /* Handle of the Distance characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x001Fu, /* Handle of the Custom Descriptor descriptor */ 
                    0x0020u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Batt1 characteristic */
            {
                0x0022u, /* Handle of the Batt1 characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x0023u, /* Handle of the Custom Descriptor descriptor */ 
                    0x0024u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },

            /* Batt2 characteristic */
            {
                0x0026u, /* Handle of the Batt2 characteristic */ 
                
                /* Array of Descriptors handles */
                {
                    0x0027u, /* Handle of the Custom Descriptor descriptor */ 
                    0x0028u, /* Handle of the Client Characteristic Configuration descriptor */ 
                }, 
            },
        }, 
    },
};


#endif /* (0u != CYBLE_CUSTOMS_SERVICE_COUNT) */

#if(0u != CYBLE_CUSTOMC_SERVICE_COUNT)

#endif /* (0u != CYBLE_CUSTOMC_SERVICE_COUNT) */


/* [] END OF FILE */
