/*******************************************************************************
* File Name: Batt1ADC_intClock.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_Batt1ADC_intClock_H)
#define CY_CLOCK_Batt1ADC_intClock_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void Batt1ADC_intClock_StartEx(uint32 alignClkDiv);
#define Batt1ADC_intClock_Start() \
    Batt1ADC_intClock_StartEx(Batt1ADC_intClock__PA_DIV_ID)

#else

void Batt1ADC_intClock_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void Batt1ADC_intClock_Stop(void);

void Batt1ADC_intClock_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 Batt1ADC_intClock_GetDividerRegister(void);
uint8  Batt1ADC_intClock_GetFractionalDividerRegister(void);

#define Batt1ADC_intClock_Enable()                         Batt1ADC_intClock_Start()
#define Batt1ADC_intClock_Disable()                        Batt1ADC_intClock_Stop()
#define Batt1ADC_intClock_SetDividerRegister(clkDivider, reset)  \
    Batt1ADC_intClock_SetFractionalDividerRegister((clkDivider), 0u)
#define Batt1ADC_intClock_SetDivider(clkDivider)           Batt1ADC_intClock_SetDividerRegister((clkDivider), 1u)
#define Batt1ADC_intClock_SetDividerValue(clkDivider)      Batt1ADC_intClock_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define Batt1ADC_intClock_DIV_ID     Batt1ADC_intClock__DIV_ID

#define Batt1ADC_intClock_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define Batt1ADC_intClock_CTRL_REG   (*(reg32 *)Batt1ADC_intClock__CTRL_REGISTER)
#define Batt1ADC_intClock_DIV_REG    (*(reg32 *)Batt1ADC_intClock__DIV_REGISTER)

#define Batt1ADC_intClock_CMD_DIV_SHIFT          (0u)
#define Batt1ADC_intClock_CMD_PA_DIV_SHIFT       (8u)
#define Batt1ADC_intClock_CMD_DISABLE_SHIFT      (30u)
#define Batt1ADC_intClock_CMD_ENABLE_SHIFT       (31u)

#define Batt1ADC_intClock_CMD_DISABLE_MASK       ((uint32)((uint32)1u << Batt1ADC_intClock_CMD_DISABLE_SHIFT))
#define Batt1ADC_intClock_CMD_ENABLE_MASK        ((uint32)((uint32)1u << Batt1ADC_intClock_CMD_ENABLE_SHIFT))

#define Batt1ADC_intClock_DIV_FRAC_MASK  (0x000000F8u)
#define Batt1ADC_intClock_DIV_FRAC_SHIFT (3u)
#define Batt1ADC_intClock_DIV_INT_MASK   (0xFFFFFF00u)
#define Batt1ADC_intClock_DIV_INT_SHIFT  (8u)

#else 

#define Batt1ADC_intClock_DIV_REG        (*(reg32 *)Batt1ADC_intClock__REGISTER)
#define Batt1ADC_intClock_ENABLE_REG     Batt1ADC_intClock_DIV_REG
#define Batt1ADC_intClock_DIV_FRAC_MASK  Batt1ADC_intClock__FRAC_MASK
#define Batt1ADC_intClock_DIV_FRAC_SHIFT (16u)
#define Batt1ADC_intClock_DIV_INT_MASK   Batt1ADC_intClock__DIVIDER_MASK
#define Batt1ADC_intClock_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_Batt1ADC_intClock_H) */

/* [] END OF FILE */
