/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <main.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

uint32 ch;
uint16 Batt1ADCResult;
uint16 Batt1ADCVal;
uint16 Batt2ADCResult;
uint16 Batt2ADCVal;
uint16 TempADCResult;
uint16 TempADCVal;

float Ah,V,A,S,D;
char Ahs[9],Vs[7],As[7],Ss[7],Ds[9];
char buffy[40];        // reserve a buffer
const char s[2] = "\t";     // for strtok, Cycle Analyst send TAB delimited data
int i = 0;


extern uint8 deviceConnected;
extern uint8 startNotification;	
extern uint8 restartAdvertisement;

int main()
{

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    CyGlobalIntEnable; 
    CyBle_Start(CustomEventHandler);
    Status_LED_SetDriveMode(Status_LED_DM_STRONG);
    UART_CA_Start();
    
    ADC_Start();
    ADC_StartConvert();
    ADC_IsEndConversion(ADC_RETURN_STATUS);

    while(1)
    {
        
        CyBle_ProcessEvents();
        HandleStatusLED();

        Batt1ADCResult = ADC_GetResult16(0);
        if (Batt1ADCResult > 0 ) Batt1ADCVal = Batt1ADCResult;
        Batt2ADCResult = ADC_GetResult16(1);
        if (Batt2ADCResult > 0 ) Batt2ADCVal = Batt2ADCResult;
        TempADCResult = ADC_GetResult16(2);
        if (TempADCResult > 0 ) TempADCVal = TempADCResult;
        
        ch = UART_CA_UartGetChar();
        if ( 0u != ch ) {
            buffy[i++] = ch;   // put it in buffer
            if ( ch == '\n' ) {     // got a line
                buffy[--i] = '\0';    // null terminate it in place of the \n
                if ( buffy[0] != 'A' ) {    // skip the CA header
                    strcpy(Ahs,strtok(buffy,s));        // when uart returns a newline, parse it
                    strcpy(Vs,strtok(NULL,s));
                    strcpy(As,strtok(NULL,s));
                    strcpy(Ss,strtok(NULL,s));
                    strcpy(Ds,strtok(NULL,s));
                    Ah = atof(Ahs);
                    V = atof(Vs);
                    A = atof(As);
                    S = atof(Ss);
                    D = atof(Ds);
                    
                    SendData(Ah,V,A,S,D,Batt1ADCVal,Batt2ADCVal,TempADCVal);
                    }
                i = 0;
            }
        }

        if(restartAdvertisement)
		{
			restartAdvertisement = FALSE;
			CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);	
		}
    }
}





/* [] END OF FILE */
